/****************************************************************************
 *
 * Copy right:   2020-, Copyrigths of QIXIANG TECH Ltd.
 * File name:    app.c
 * Description:  QX app source file 
 * History:      Rev1.0   2020-10-16
 * Athuor:       chenjie 
 *
 ****************************************************************************/
//include 
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "app.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include <cis_def.h>
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"

//define
// app task static stack and control block
#define PROC_TASK_STACK_SIZE    (1024)


//uart def
#define Uart_Send_LEN         (8)
#define Uart_Rece_LEN         (16)
#define RTE_UART_RX_IO_MODE      RTE_UART1_RX_IO_MODE

//statement variable
extern ARM_DRIVER_USART Driver_USART1;
static ARM_DRIVER_USART *USARTdrv = &Driver_USART1;

/** \brief usart receive buffer */
uint8_t Uart_Data_buffer[8];

/** \brief usart send buffer */

/** \brief receive timeout flag */
volatile bool isRecvTimeout = false;

/** \brief receive complete flag */
volatile bool isRecvComplete = false;

uint8_t process0SlpHandler     = 0xff;
uint8_t process1SlpHandler     = 0xff;
uint8_t process2SlpHandler     = 0xff;

/** \brief 电压传输 */

typedef enum
{
    PROCESS1_STATE_IDLE = 0,
    PROCESS1_STATE_WORK,
    PROCESS1_STATE_SLEEP
}process1SM;
typedef enum
{
    PROCESS2_STATE_IDLE = 0,
    PROCESS2_STATE_WORK,
    PROCESS2_STATE_SLEEP
}process2SM;

static StaticTask_t           gProcessTask0;
static UINT8                    gProcessTaskStack0[PROC_TASK_STACK_SIZE];
static StaticTask_t           gProcessTask1;
static UINT8                    gProcessTaskStack1[PROC_TASK_STACK_SIZE];
static StaticTask_t           gProcessTask2;
static UINT8                    gProcessTaskStack2[PROC_TASK_STACK_SIZE];

process1SM 	gProc1State = PROCESS1_STATE_IDLE;
process2SM 	gProc2State = PROCESS2_STATE_IDLE;
#define PROC1_STATE_SWITCH(a)  (gProc1State = a)
#define PROC2_STATE_SWITCH(a)  (gProc2State = a)


static void process0AppTask(void* arg)
{
    uint32_t inParam = 0xAABBCCDD;
    uint32_t cnt;
    slpManSetPmuSleepMode(true,SLP_HIB_STATE,false);
    slpManApplyPlatVoteHandle("process0slp",&process0SlpHandler);
    slpManSlpState_t slpstate = slpManGetLastSlpState();
    UINT8 Can_index = 0;
    UINT8 Uart_index = 0;
    while(1)
    {
        osDelay(10);//10ms
        Can_index++;
        Uart_index++;
        if (Uart_index >10)//Uart 100ms 调用一次
        {
            PROC2_STATE_SWITCH(PROCESS2_STATE_WORK);
            Uart_index = 0;
        }
        if (Can_index >=100)//Can 1000ms 调用一次
        {
            PROC1_STATE_SWITCH(PROCESS1_STATE_WORK);
            Can_index = 0;
        } 
    }
}
void TcpCallBack(void)
{
    #ifdef USING_PRINTF
        printf("[%d]TcpCallBacl",__LINE__);
    #endif
}
static void process1AppTask(void* arg)
{
    int TcpConnectID = -1;
    int TcpSendID = 0;
    time_t timesec;
    OsaUtcTimeTValue timestracture;
    uint8_t TcpSendBuffer[92] = {0x23,0x23,0x02,0xFE,0x47,0x59,0x54,0x45,0x53,0x54,
                                0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
                                0x31,0x01,0x00,0x43,0x14,0x0B,0x07,0x0E,0x39,0x37,
                                0x8C,0x14,0x0B,0x07,0x0E,0x39,0x37,0x1A,0x00,0x00,
                                0x00,0x00,0x00,0x02,0x15,0x02,0x15,0x03,0x43,0x64,
                                0x0E,0x00,0x00,0x00,0x00,0x0E,0x53,0x0E,0x53,0x0E,
                                0x53,0x0E,0x53,0x0E,0x53,0x0E,0x53,0x0E,0x53,0x0E,
                                0x53,0x0E,0x53,0x0E,0x53,0x0E,0x53,0x0E,0x53,0x0E,
                                0x53,0x0E,0x53,0x05,0x13,0x13,0x13,0x13,0x13,0x00,
                                0x00,0x2D};
	PROC1_STATE_SWITCH(PROCESS1_STATE_IDLE);
    CHAR   serverip[] = "47.97.127.222";
    UINT16 serverport = 8712;
    while(1)
    {
        switch(gProc1State)
        {
            case PROCESS1_STATE_IDLE:
            {
                FaultDisplay(LED_TURN_OFF);
                break;
            }
            case PROCESS1_STATE_WORK:
            {
                while(TcpConnectID<=0)
                {
                    TcpConnectID = tcpipConnectionCreate(1,PNULL,PNULL,serverip,serverport,TcpCallBack);
                }
                TcpSendID  = tcpipConnectionSend(TcpConnectID,TcpSendBuffer,92,PNULL,PNULL,PNULL);
                appGetSystemTimeSecsSync(&timesec);
                appGetSystemTimeUtcSync(&timestracture);
                #ifdef USING_PRINTF
                    printf("[%d]TcpConnectID:%d \r\n",__LINE__,TcpConnectID);
                #endif
                #ifdef USING_PRINTF
                    printf("[%d]TcpSendID:%d \r\n",__LINE__,TcpSendID);
                #endif
                #ifdef USING_PRINTF
                    printf("[%d]Time:%d \r\n",__LINE__,timesec);
                #endif
                #ifdef USING_PRINTF
                    printf("[%d]Time1:%x TIme2:%x \r\n",__LINE__,timestracture.UTCtimer1,timestracture.UTCtimer2);
                #endif
                ECOMM_TRACE(UNILOG_PLA_APP, ec_autoReg102, P_SIG, 0, "ECOMM_Test");
                FaultDisplay(LED_TURN_ON);
                PROC1_STATE_SWITCH(PROCESS1_STATE_SLEEP);	
                break;
            }
            case PROCESS1_STATE_SLEEP:
            {                                     
                break;
            }
        }
    }
}
/**
  \fn          process0Init(void)
  \brief       process0Init function.
  \return
*/
void process0Init(void)
{
    osThreadAttr_t task_attr;
#ifndef USING_PRINTF
    if(BSP_GetPlatConfigItemValue(PLAT_CONFIG_ITEM_LOG_CONTROL) != 0)
    {
        HAL_UART_RecvFlowControl(false);
    }
#endif

    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcessTaskStack0, 0xA5,PROC_TASK_STACK_SIZE);
    task_attr.name = "Process0AppTask";
    task_attr.stack_mem = gProcessTaskStack0;
    task_attr.stack_size = PROC_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;//osPriorityBelowNormal;
    task_attr.cb_mem = &gProcessTask0;//task control block
    task_attr.cb_size = sizeof(StaticTask_t);//size of task control block

    osThreadNew(process0AppTask, NULL, &task_attr);
}
/**
  \fn          process1Init(void)
  \brief       process1Init function.
  \return
*/
void process1Init(void)
{
    osThreadAttr_t task_attr;
#ifndef USING_PRINTF
    if(BSP_GetPlatConfigItemValue(PLAT_CONFIG_ITEM_LOG_CONTROL) != 0)
    {
        HAL_UART_RecvFlowControl(false);
    }
#endif

    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcessTaskStack1, 0xA5,PROC_TASK_STACK_SIZE);
    task_attr.name = "Process1AppTask";
    task_attr.stack_mem = gProcessTaskStack1;
    task_attr.stack_size = PROC_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;//osPriorityBelowNormal;
    task_attr.cb_mem = &gProcessTask1;//task control block
    task_attr.cb_size = sizeof(StaticTask_t);//size of task control block

    osThreadNew(process1AppTask, NULL, &task_attr);
}
/**
  \fn          process2Init(void)
  \brief       process2Init function.
  \return
*/
void process2Init(void)
{
    osThreadAttr_t task_attr;

    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcessTaskStack2, 0xA5,PROC_TASK_STACK_SIZE);
    task_attr.name = "Process2AppTask";
    task_attr.stack_mem = gProcessTaskStack2;
    task_attr.stack_size = PROC_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;//osPriorityBelowNormal;
    task_attr.cb_mem = &gProcessTask2;//task control block
    task_attr.cb_size = sizeof(StaticTask_t);//size of task control block

    osThreadNew(process2AppTask, NULL, &task_attr);
}
/**
  \fn          appInit(void)
  \brief       appInit function.
  \return
*/
void appInit(void *arg)
{   
    process0Init();
	process1Init();
    process2Init();
}

/**
  \fn          int main_entry(void)
  \brief       main entry function.
  \return
*/
void main_entry(void) {

    BSP_CommonInit();
    osKernelInitialize();

    registerAppEntry(appInit, NULL);
    if (osKernelGetState() == osKernelReady)
    {
        osKernelStart();
    }
    while(1);
}